from Products.Gideon.Objects.Namespaces import *

from BTrees.IOBTree import IOSet
from Interfaces import Base


class IEventProxy(Base):

    def get_event_type(self): 
        """ get the event type """
    
    def get_event_source(self): 
        """ get the source of the event """

    
class EventQueue(Folder):
    """ simple FIFO event list """
    
    meta_type = 'Event Queue'
    
    security = ClassSecurityInfo()

    def __init__(self, id='EventQueue'):
        self.id = id
        self._data = IOSet()
        
    def add_event(self, event):
        if IEventProxy.implementedBy(event):
            self._data.insert(event)
        else: raise "Event does not support Event Proxy Interface"

    def get_filtered_events(self, event_filter):
        return map(event_filter, self._data)
        
    def remove_event(self, i):
        self._data.remove(i)

    def __getitem__(self, i):
        return self._data[i]
    
    def reset(self): # debugging only
        self._data = IOSet()        
        
        

        