# File: eventlog.py
# Author: Kapil Thangavelu
# License: GPL
# CVS: $Id: eventlog.py,v 1.1.1.1 2001/12/31 04:07:06 ender Exp $
# Description: simple logging singleton

import time
from threading import Lock
l = Lock()
_a = l.acquire
_r = l.release
del l

class EventLog:
    
    LOGLEVEL=4
    LOGFILE='/home/ender/workspace/EventChannel/log.txt'
    
    _levels = {}
    _levels['debug']=3
    _levels['warning']=2
    _levels['critical']=1    
    
    def __init__(self):
        self.fh = open(self.LOGFILE, 'w')
    
    def _log(self,msg,level, type):
        #if self.LOGLEVEL>level:
        _a()
        try:
            msg = "[%s] %s: %s\n"%( time.ctime(time.time()), type, str(msg))               
            print msg
            self.fh.write(msg)
            self.fh.flush()
        finally:
            _r()

    def warning(self,msg):
        self._log(msg, self._levels['warning'], 'warning')
                  
    def debug(self,msg):
        self._log(msg, self._levels['debug'], 'debug')
        
    def critical(self,msg):
        self._log(msg, self._levels['critical'], 'critical')

log=EventLog()
del EventLog
