from OFS.ObjectManager import ObjectManager
from Products.EventChannel.eventchannel import get_uid


## container managed events

class FolderEventSource:

    def _setObject(self, id, object, roles=None, user=None, set_owner=1):

        ObjectManager._setObject(self, id, object, roles, user, set_owner)
        obj = getattr(self, id)
        ec = self.get_event_channel()
        ec.publish(obj, "object added", get_uid(self))        

    def _delObject(self, id):

        obj = getattr(self, id)
        self.get_event_channel().publish(obj, "object deleted", get_uid(self))
        ObjectManager._delObject(self, id)
        
    def manage_afterAdd(self, item, container):
        ec = self.get_event_channel()
        ec.register_source(self, "object added")
        ec.register_source(self, "object deleted")

## object managed events        

class ObjectEventSource:
    
    def manage_afterAdd(self, item, container):
        ec = self.get_event_channel()
        ec.register_source(self, "object added")
        ec.register_source(self, "object deleted")
        ec.register_source(self, "object cloned")
        ec.publish(self, "object added")
        
    def manage_afterClone(self, item):
        ec = self.get_event_channel()
        ec.publish(self, "object cloned")
        
    def manage_beforeDelete(self, item, container):
        ec = self.get_event_channel()
        ec.publish(self, "object deleted")
